%{!?python_sitearch: %global python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)" 2>/dev/null)}
%{?!pybasever: %global pybasever %(python -c "import sys; print sys.version[:3]" 2>/dev/null || echo 0.0)}

Name:		python-twisted-web
Version:	12.1.0
Release:	1.0.cf%{?dist}
Summary:	Twisted web client and server, programmable in Python
Group:		Development/Libraries
License:	MIT
URL:		http://twistedmatrix.com/trac/wiki/TwistedWeb
Source0:	http://twistedmatrix.com/Releases/Web/12.1/TwistedWeb-%{version}.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	python-twisted-core >= 12.1.0, python2-devel >= 2.5
Requires:	python-twisted-core >= 12.1.0
Requires:	SOAPpy

# a noarch-turned-arch package should not have debuginfo
%global debug_package %{nil}

%description
Twisted is an event-based framework for Internet applications.

Twisted Web is a complete web server, aimed at hosting web applications using
Twisted and Python, but fully able to serve static pages too.

%prep
%setup -n TwistedWeb-%{version} -q

# Remove spurious shellbangs
sed -i -e '/^#! *\/usr\/bin\/python/d' twisted/web/test/test_cgi.py
sed -i -e '/^#! *\/usr\/bin\/python/d' twisted/web/test/test_distrib.py

%build
python setup.py build

%install
rm -rf %{buildroot}

# This is a pure python package, but extending the twisted namespace from
# python-twisted-core, which is arch-specific, so it needs to go in sitearch
python setup.py install -O1 --install-purelib %{python_sitearch} --skip-build --root %{buildroot}

# See if there's any egg-info
if [ -f %{buildroot}%{python_sitearch}/Twisted_Web-%{version}-py%{pybasever}.egg-info ]; then
	echo %{python_sitearch}/Twisted_Web-%{version}-py%{pybasever}.egg-info
fi > egg-info

%clean
rm -rf %{buildroot}

%post
if [ -x %{_libexecdir}/twisted-dropin-cache ]; then
	%{_libexecdir}/twisted-dropin-cache || :
fi

%postun
if [ -x %{_libexecdir}/twisted-dropin-cache ]; then
	%{_libexecdir}/twisted-dropin-cache || :
fi

%files -f egg-info
%doc LICENSE NEWS README doc/*
%{python_sitearch}/twisted/plugins/twisted_web.py*
%{python_sitearch}/twisted/web/

%changelog
* Wed Jun  6 2012 Paul Howarth <paul@city-fan.org> 12.1.0-1.0.cf
- update to 12.1.0 (see NEWS for details)
- drop %%defattr, redundant since rpm 4.4

* Mon Feb 13 2012 Paul Howarth <paul@city-fan.org> 12.0.0-1.0.cf
- update to 12.0.0
  - twisted.web.util.redirectTo now raises TypeError if the URL passed to it
    is a unicode string instead of a byte string (#5236)
  - the new class twisted.web.template.CharRef provides support for inserting
    numeric character references in output generated by twisted.web.template
    (#5408)
  - the Twisted Web howto now has a section on proxies and reverse proxies
    (#399)
  - the web client howto now covers ContentDecoderAgent and links to an
    example of its use (#5415)
  - correct the Element example to use the correct tag API (#5404)
  - fix a typo in the WSGI howto (#5438)
- twisted now requires at least python 2.5

* Mon Jan  9 2012 Paul Howarth <paul@city-fan.org> 11.1.0-2.0.cf
- rebuilt for gcc-4.7 in Rawhide

* Fri Nov 18 2011 Paul Howarth <paul@city-fan.org> 11.1.0-1.0.cf
- update to 11.1.0 (see NEWS for details)
- upstream source distribution has moved to twistedmatrix.com

* Mon Apr  4 2011 Paul Howarth <paul@city-fan.org> 11.0.0-1.0.cf
- update to 11.0.0 (see NEWS for details)
- nobody else likes macros for commands

* Tue Nov 30 2010 Paul Howarth <paul@city-fan.org> 10.2.0-1.0.cf
- update to 10.2.0:
  - twisted.web.xmlrpc.XMLRPC.xmlrpc_* methods can now be decorated using
    withRequest to cause them to be passed the HTTP request object (#3073)
  - twisted.web.xmlrpc.QueryProtocol.handleResponse now disconnects from the
    server, meaning that Twisted XML-RPC clients disconnect from the server as
    soon as they receive a response, rather than relying on the server to 
    disconnect (#2518)
  - twisted.web.twcgi now generates responses containing all occurrences of
    duplicate headers produced by CGI scripts, not just the last value (#4742)
  - twisted.web.trp, which has been deprecated since Twisted 9.0, was removed
    (#4299)
  - improve lore2sphinx buildbot results for projects/web (#4576, #4577)
  - in _newclient.HTTP11ClientProtocol, clarify the message logged when the
    connection is lost before generation fails (#4709)
  - link to HTTPClientFactory from the getPage docstring (#4723)
- BR: python2-devel rather than just python-devel

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> 10.1.0-1.1.cf
- rebuild for python 2.7 in Rawhide

* Mon Jul  5 2010 Paul Howarth <paul@city-fan.org> 10.1.0-1.0.cf
- update to 10.1.0 (see NEWS for details)
- Twisted now requires python >= 2.4

* Thu Mar  4 2010 Paul Howarth <paul@city-fan.org> 10.0.0-1.0.cf
- update to 10.0.0 (see NEWS for details)

* Wed Nov 25 2009 Paul Howarth <paul@city-fan.org> 9.0.0-1.0.cf
- update to 9.0.0

* Fri Aug  7 2009 Paul Howarth <paul@city-fan.org> 8.2.0-3.0.cf
- define RPM macros in global scope
- tidy up egg-info handling

* Sun Jul 26 2009 Paul Howarth <paul@city-fan.org> 8.2.0-2.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jan 16 2009 Paul Howarth <paul@city-fan.org> 8.2.0-1.0.CF
- update to 8.2.0
- make sure the scriptlets never return a non-zero exit status

* Mon May 19 2008 Paul Howarth <paul@city-fan.org> 8.1.0-1
- update to 8.1.0

* Tue Apr  1 2008 Paul Howarth <paul@city-fan.org> 8.0.0-1
- update to 8.0.0

* Wed Jan 10 2007 Paul Howarth <paul@city-fan.org> 0.7.0-1
- update to 0.7.0
- require python-twisted-core >= 2.5.0
- websetroot no longer included (didn't work anyway)

* Mon Dec 11 2006 Paul Howarth <paul@city-fan.org> 0.6.0-5
- rebuild for python 2.5 on Rawhide
- fix for mock build with no python in initial buildroot
- buildreq python-devel again

* Wed Nov 22 2006 Paul Howarth <paul@city-fan.org> 0.6.0-4
- add %%post and %%postun scriptlets to regenerate the dropin.cache

* Mon Sep  4 2006 Paul Howarth <paul@city-fan.org> 0.6.0-3
- drop unnecessary python-devel buildreq
- don't create debuginfo package
- update summary abd description
- don't ghost .pyo files

* Fri Jun  9 2006 Paul Howarth <paul@city-fan.org> 0.6.0-2
- build as arch-specific package for proper integration with twisted-core
  (see http://www.redhat.com/archives/fedora-extras-list/2006-June/msg00264.html)
- script the python files list generation to clean up the spec

* Wed May 31 2006 Paul Howarth <paul@city-fan.org> 0.6.0-1
- update to 0.6.0
- add doc files LICENSE and NEWS
- update URL

* Wed May 10 2006 Paul Howarth <paul@city-fan.org> 0.5.0-3
- import from PyVault Repository
- rewrite in Fedora Extras style
- change python-soappy dep to SOAPpy for Fedora Extras compatibility

* Tue Aug 23 2005 Jeff Pitman <symbiont+pyvault@berlios.de> 0.5.0-2
- disttag

* Wed Mar 16 2005 Jeff Pitman <symbiont+pyvault@berlios.de> 0.5.0-0.1.a3
- upstream release

* Sat Mar 12 2005 Jeff Pitman <symbiont+pyvault@berlios.de> 0.5.0-0.1.a2
- prerelease; FE versioning

* Mon Feb 07 2005 Jeff Pitman <symbiont+pyvault@berlios.de> 0.1.0-1
- prep for split

